-- sort.lua
-- Written By MrJackdaw, tweak by Habna for HugeBag


PreSortTimer = Turbine.UI.Control();
SortMethod1Timer = Turbine.UI.Control();
SortMethod2Timer = Turbine.UI.Control();
FailSafeTimer = Turbine.UI.Control();

function Sort()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write( L["FSSortE"] );
		return
	end

	IsSorting = true;
	ButtonsCtr:SetVisible( false );
	FirstStart = Turbine.Engine.GetGameTime();
	Start = Turbine.Engine.GetGameTime();
	lastfoundat, x = nil, backpackSize;
	WasMoved = {};
	
	FailSafe();
	--PreSort(); --If enabled then preferred method can be enabled at line 33 or 34
	--SortMethod1(); --Disable if using PreSort() // New sorting method
	SortMethod2(); --Disable if using PreSort() // Old sorting method
end

function PreSort()
	PreSortTimer.Update = function( sender, args )
		if x < 1 then -- Stop when first slot is reached
			PreSortTimer:SetWantsUpdates( false );
			--SortMethod1(); --New sorting method
			SortMethod2(); --Old sorting method
		else
			item = Backpack:GetItem( x );
			
			if WasMoved[x] and item ~= nil then
				--if not bwrite then
					--write("Item ".. x .. " was moved but backpack is not updated, waiting update!");
					--bwrite = true;
				--end
				return
			end
			--bwrite = false;

			if item == nil then
				--write("Empty slot found at " .. x);
				if lastfoundat == nil then lastfoundat = x; end
				for xx = lastfoundat-1, 1, -1 do
					ii = Backpack:GetItem( xx );
					if ii ~= nil then
						--write("Performing item drop from " .. xx .. " to " .. x);
						Backpack:PerformItemDrop(ii, x, false);
						lastfoundat = xx;
						WasMoved[xx] = true;
						break
					end
				end
			else
				--write("Item in slot " .. x .. " ("..item:GetName()..")");
			end
			x = x - 1;
		end
	end
	
	PreSortTimer:SetWantsUpdates( true );
end

function SortMethod1()	
	CreateVirtualPack();

	Slot = 1;
	write( L["FSSortS"] );

	SortMethod1Timer.Update = function( sender, args )
		if Slot > backpackSize then --Stop when last slot is reached
			--write("Sort Method 1 finish");
			SortMethod1Timer:SetWantsUpdates( false );
			FailSafeTimer:SetWantsUpdates( false );

			if ShowButton then ButtonsCtr:SetVisible( true ); end
	
			IsSorting = false;
			write( L["FSSortF"] );
			local Time = Turbine.Engine.GetGameTime();
			write("<rgb=#888888>" .. L["Sort"] .. L["FAMergeFA"] .. string.format( "%.2f", Time - FirstStart ) .. L["FAMergeSec"] )
		else
			--local Time = Turbine.Engine.GetGameTime();
			--local elapsed = Time - Start;

			--if elapsed > 0.2 then
				--Get the quantity & name of the target item
				titem = Backpack:GetItem( Slot );
				if titem ~= nil then
					tName = titem:GetName();
					tQuantity = titem:GetQuantity();
					target = tQuantity .. " " .. tName;
				else
					target = "zEmpty";
				end
			
				--if VirtPack[Slot].Name ~= titem:GetName() then
					--if not bwrite then
						--write("Item in ".. Slot .. " does not match item in Virtual backpack, waiting update!");
						--bwrite = true;
					--end
					--return
				--end
				--bwrite = false;
			
				AtSlot = VirtPack[Slot].AtSlot;
				item = Backpack:GetItem( AtSlot );
				if VirtPack[Slot].Name ~= "zEmpty" then --To prevent from dropping empty slot
					if Slot ~= AtSlot then --To prevent from dropping item if it's already at the right slot
						--write("Performing item drop from " .. AtSlot .. " to " .. Slot);
						Backpack:PerformItemDrop(item, Slot, false);
						VirtPack[Slot].AtSlot = Slot; --Item was moved so change the AtSlot variable to reflect the change
						--If item in the destination slot, find it in the virtual back pack to change his AtSlot variable to reflect the change
						if target ~= "zEmpty" then
							for k, v in pairs(VirtPack) do
								if v.Name == tName and v.Quantity == tQuantity then
									v.AtSlot = AtSlot;
								end
							end
						end
						--
						Start = Turbine.Engine.GetGameTime();
					end
				end
				Slot = Slot + 1;
			--end
		end
	end

	SortMethod1Timer:SetWantsUpdates( true );
end

function SortMethod2()	
	CreateVirtualPack();

	Slot = 1;
	write( L["FSSortS"] );

	SortMethod2Timer.Update = function( sender, args )
		if Slot > backpackSize then -- Stop when last slot is reached
			write("Sort Method 2 finish");
			SortMethod2Timer:SetWantsUpdates( false );
			FailSafeTimer:SetWantsUpdates( false );

			if ShowButton then ButtonsCtr:SetVisible( true ); end
	
			IsSorting = false;
			write( L["FSSortF"] );
			local Time = Turbine.Engine.GetGameTime();
			write("<rgb=#888888>" .. L["Sort"] .. L["FAMergeFA"] .. string.format( "%.2f", Time - FirstStart ) .. L["FAMergeSec"] )
		else
			--Get the quantity & name of the target item
			targetName = VirtPack[Slot].Name;
			target = VirtPack[Slot].Quantity .. " " .. targetName;
		
			--Search the target item in bag.
			for i = Slot, backpackSize do
				item = Backpack:GetItem( i );

				if item ~= nil then
					itemName = item:GetName();
					itemQuantity = item:GetQuantity();
				else
					itemName = "zEmpty";
					itemQuantity = 0;
				end
				source = itemQuantity .. " " .. itemName;
				--write(source .. " / " .. target);
				if source == target then
					if i == Slot then Slot = Slot + 1 return end
					--write(source .. " found at " .. i .. " / Slot " .. Slot .. ": " .. target);
					-- Check if item in destination slot is not the same item that will go there, cause if true them a merge will
					-- be perform and sort will not end properly, making button not visible and can't perform sort again.
					local ditem = Backpack:GetItem( Slot );
					if ditem ~= nil then
						ditemName = ditem:GetName();
						ditemMaxStackSize = ditem:GetMaxStackSize(); -- if max = 1 then it's not stackable
						--write("Slot: " .. i .. " item max stack size is : " .. ditemMaxStackSize);
						--write(ditemName .. " / " .. itemName);
						if ditemName == itemName then
							-- check if destination item is stackable
							--write(ditemMaxStackSize);
							if ditemMaxStackSize > 1 then
								--write("Moving item in " .. Slot .. " to a free slot");
								-- Yes it's stackable and same name. Move it to an empty slot
								local found = false;
								for FreeSlot = Slot + 1, backpackSize do
									local freeLoc = Backpack:GetItem( FreeSlot );
									if freeLoc == nil then -- Free space found
										found = true;
										--write("Free slot found at " .. FreeSlot);
										Backpack:PerformItemDrop(ditem, FreeSlot, false);
										break
									end
								end
								--write("Found: " .. tostring(found));
								-- No free slot was found in bag, move to next slot that is not same item name
								if not found then
									--write("No free slot available. Moving to next slot");
									for NextSlot = Slot + 1, backpackSize do
										--write(tostring(NextSlot));
										local nextItem = Backpack:GetItem( NextSlot );
										if nextItem ~= nil then
											nitemName = nextItem:GetName();
											if nitemName ~= ditemName then
												Backpack:PerformItemDrop(ditem, NextSlot, false);
												break
											end
										end
									end
								end
							end
						end
					end
					
					if Lasti == i then
						Lasti = nil;
						i = i - 1;
					else
						if item ~= nil then
							--write("Performing item drop to slot " .. i);
							Backpack:PerformItemDrop(item, Slot, false);
							Lasti = i; --Last item move (slot number)
							Slot = Slot + 1;
							return
						end
					end
				end
			end
		end
	end

	SortMethod2Timer:SetWantsUpdates( true );
end

function FailSafe()
	NumSecs = 0;
	MaxSecs = 15; --Number of seconds before fail safe reload HugeBag. (In case sort fail to finish within it's allowed time)

	FailSafeTimer.Update = function( sender, args )
		currentdate = Turbine.Engine.GetDate();
		currentsecond = currentdate.Second;

		if NumSecs > MaxSecs then --Stop the sorting if it take more then it's allowed secs to complete.
			write( L["FSSortFS"] .. MaxSecs .. L["FAMergeSec"]);

			FailSafeTimer:SetWantsUpdates( false );
			PreSortTimer:SetWantsUpdates( false );
			SortMethod1Timer:SetWantsUpdates( false );
			SortMethod2Timer:SetWantsUpdates( false );

			if ShowButton then ButtonsCtr:SetVisible( true ); end
	
			IsSorting = false;
			--ReloadHugeBag();
		else
			if (oldsecond ~= currentsecond) then --Add 1 to NumSecs every real second
				oldsecond = currentsecond;
				NumSecs = NumSecs + 1;
			end
		end
	end

	FailSafeTimer:SetWantsUpdates( true );
end